<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scan_source_practice".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ScanSourcePractice".
 *
 * Columns in table "scan_source_practice" available as properties of the model,
 * followed by relations of table "scan_source_practice" available as properties of the model.
 *
 * @property integer $id
 * @property integer $scan_result_practice_id
 * @property string $input_hash
 * @property string $source_data
 *
 * @property ScanResultPractice $scanResultPractice
 */
abstract class BaseScanSourcePractice extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scan_source_practice';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ScanSourcePractice|ScanSourcePractices', $n);
    }

    public static function representingColumn()
    {
        return 'input_hash';
    }

    public function rules()
    {
        return array(
            array('scan_result_practice_id', 'required'),
            array('scan_result_practice_id', 'numerical', 'integerOnly' => true),
            array('input_hash', 'length', 'max' => 32),
            array('source_data', 'safe'),
            array('input_hash, source_data', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, scan_result_practice_id, input_hash, source_data', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'scanResultPractice' => array(self::BELONGS_TO, 'ScanResultPractice', 'scan_result_practice_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'scan_result_practice_id' => null,
            'input_hash' => Yii::t('app', 'Input Hash'),
            'source_data' => Yii::t('app', 'Source Data'),
            'scanResultPractice' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('scan_result_practice_id', $this->scan_result_practice_id);
        $criteria->compare('input_hash', $this->input_hash, true);
        $criteria->compare('source_data', $this->source_data, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
